NB. circle flower

circ_flower=: 3 : 0
NB. Usage:  circ_flower 3 1 
NB. petal is 2 * R0  --> 5 is 2.5 // 1 is 0.5  
'R0 Beki'=. y    
NB.  0.07 is Scale parameter 
R=. Beki ^~| sin R0 *  T=. 0.07 * i. 360
R polar_xy T
)
polar_xy=: 4 : '|: ;("1),.x * L:0 (cos;sin)L:0 y' NB. y is T
minmax_dwin=: ;@(<./ ; >./) L:0                   NB. find min-max 

NB. ---------------------
rotm_elongm=: 4 : 0
NB.   (plot {|:) 4 10 rotm_elongm  1r4p1;0.4 0.4
NB. x parameter for circ_flower
NB. y parameter for rotm;elongm(x,y)
'ROT ELONG'=: y
tmp=. ((circ_flower x) ,.1 )mp rotm ROT 
clean }:"1 tmp mp elongm ELONG
)

NB. ---------cubic spline----------------
NB. Usage: *  cubic_spline plot_spline EXG
NB. --- spline- tools-------------------------------
pick_sw=: 3 : '|. (L:0) 2<\ ; -/ L:0 |. (L:0) 2<\ y' 
pick2=: 3 : ' -/ L:0 |. (L:0) 2<\ y' NB. x1-x0 ..
mk_mat0=: 3 : 0
'X0 Y0'=: {|: y
'X1 Y1' =: >pick2  L:0 X0;Y0
TMP0=:;("1) >({.; +:@:+/ ;{:) (L:0) 2<\X1
NB. TMP1=:  }."1 (-i.# TMP0)|."0 1 TMP0   NB. cut L0=0 and Ln=0
IND=. (TMP1), <: TMP1=. (# TMP0) 
NB. }:@ }."1 (-i.# TMP0 )|."0 1  TMP1=:  TMP0,.(3 2 $ 0)
}:@}."1  (-i.# TMP0)|."0 1  TMP0,. IND$0 
NB. IND=. - i. <: # X0
NB. 0,(IND |."0 1 TMP2),0
)

mk_vc0=: 3 : 0
'X0 Y0'=: {|: y
'X1 Y1' =: > pick2 L:0 X0;Y0
6*; -/ (L:0) |.(L:0)  2<\ Y1%X1
)

calc_sp3c=: mk_vc0 %. mk_mat0 NB. calc c
NB. Usage:  calc_sp3c EXG

calc_cubic_spline=: 3 : 0
NB. u EXG
'X0 Y0'=: {|: y
'X1 Y1' =: > pick2 L:0 X0;Y0
Li=: 0,~ 0, calc_sp3c y   NB. li / add 0 to each side
Ai=: }: Y0                NB. 
Bi=. (Y1%X1)-(X1%6)* ; +/ (L:0) 2 1 * (L:0)2<\ Li
Ci=. -: Li                NB. Li/2
Di=. (; -/@:|.( L:0) 2<\ Li) % 6*X1
(}:Li),.Ai,.Bi,.(}:Ci),.Di   NB. Li Ai Bi Ci Di
)


cubic_spline=: 3 : 0
NB. u EXG
'X0 Y0'=: {|: y
'X1 Y1' =: > pick2 L:0 X0;Y0
NUM=: }. L:0 TMP0=. }: L:0 steps L:0 (2<\X0),(L:0) 10 NB. divide each span by 10 points
PARAM=:{ }."1 calc_cubic_spline y   NB. parametor ai bi ci di
TMP1=. NUM - L:0 {@>}:X0             NB. x-xi
DX=: ({: L:0 PARAM)*L:0 ^&3 L:0 TMP1 NB. Di(x-xi)^3 
CX=: (2{ L:0 PARAM)*L:0 *:L:0 TMP1   NB. Ci(x-xi)^2
BX=: (1{L:0 PARAM) * L:0 TMP1        NB. Bi(x-xi)
AX=: {. L:0 PARAM                    NB. Ai
ANS=: AX + L:0 BX + L:0 CX + L:0 DX  NB. sum a,b,c,d
POINT=: {@> {:"1 y                   NB. yi
({: y),~(; TMP0),.;(}: POINT), L:0 ANS  NB. recover xi,yi
)

 plot_spline=: 1 : 0
NB.  cubic_spline plot_round_calc EX518
pd 'reset'
pd 'color red'
pd 'type line marker'
pd {|: y
pd 'type line'
pd 'color blue'
pd DAT=. {|: u y
pd 'show'
)

 
NB. Wikipedia Example
EXW=: _1 0.5, 0 0 ,: 3 3 
NB. Snezhana Gocheva-Ileva
EXG=: 3.0 4.5 7.0 9.0,. 2.5 1.0 2.5 0.5


NB. ======================================
NB. 8 Besier curves
NB. -3ji bezier curves--------------------
NB.Besier
NB. Besier matrix form
require 'plot numeric'

NB. * plot {@|:  ;("2),.  calc_bezier4 L:0 form_bezier4 a
NB. * plot {@|:  3 4 3 3 4 calc_bezier_mix i. 20 2
NB. * 3 plot_bezier EXW
NB. * 4 plot_bezier EXG
  

NB. -----main 3/4------------------------------
calculus_bezier4=: 3 : ';("1) calc_bezier4 L:0 form_bezier4 y'
calculus_bezier3=: 3 : ';("1) calc_bezier3 L:0 form_bezier3 y'
NB. all round
calculus_bezier_all=: 4 : 0
NB. x = 3/4/5/6 
tmp=.(# x) form_bezier_all y 
;("2),. x calc_bezier_all L:0  tmp
)
NB. ---0.----bezierMatrixForm-------------------------
mat_bezier4=:1 0 0 0,_3 3 0 0,3 _6 3 0,:_1 3 _3 1 NB.Cubic BesierMatrixForm 
mat_bezier3=: 1 0 0 , _2 2 0,: 1 _2 1
NB. ------5/6 is Kato's triangle-------------------------------
mat_bezier5=: 1 0 0 0 0 ,_4 4 0 0 0, 6 _12 6 0 0 ,_4 12 _12 4 0,:1 _4 6 _4 1
mat_bezier6=: 1 0 0 0 0 0,_5 5 0 0 0 0 , 10 _20 10 0 0 0 ,: _10 30 _30 10 0 0
mat_bezier6=: mat_bezier6, 5 _20 30 _20 5 0,: _1 5 _10 10 _5 1
NB. -------------------------------------------------
mat_bezierb=: 1 0 0 0 0 ,_4 4 0 0 0, 6 _12 7 _2 1,_4 11 _9 1 1,:1 _4 6 _4 1
NB. ----------------------------
NB. Kato's  triangle piller
NB. ---1.----calc-----------------------------------------
calc_bezier4=: 3 : 0
NB. cubic Besier
NB. Usage: (long)  calc_bezier4 L:0 form_bezier4 a// not straight-->;("2),. 
NB. Usage: (short) calc_bezier4 L0
tmp0=.|: mat_bezier4 +/ . * y
fx=. ({. tmp0)&p.      NB. set x(t) polynomial coefficients a0+a1xi+a2x2^2... 
fy=. ({: tmp0)&p.      NB. set y(t)
t01=. steps 0 1 100    NB. divede [0,1] for smooth Besier curves 
(fx t01),.fy t01       NB. calc polynomial
)

calc_bezier3=: 3 : 0
NB. dydrad bezier
tmp0=.|: mat_bezier3 +/ . * y
fx=. ({. tmp0)&p.      NB. make x(t) polynomial
fy=. ({: tmp0)&p.      NB. same y(t)
t01=. steps 0 1 100    NB. divede [0,1] for smooth Besier curves 
(fx t01),.fy t01       NB. calc polynomial
)

calc_bezier5=: 3 : 0
NB. cubic Besier
NB. Usage: (long)  calc_bezier5 L:0 form_bezier4 a// not straight-->;("2),. 
NB. Usage: (short) calc_bezier5 L0
tmp0=.|: mat_bezier5 +/ . * y
fx=. ({. tmp0)&p.      NB. set x(t) polynomial coefficients a0+a1xi+a2x2^2... 
fy=. ({: tmp0)&p.      NB. set y(t)
t01=. steps 0 1 100    NB. divede [0,1] for smooth Besier curves 
(fx t01),.fy t01       NB. calc polynomial
)


calc_bezier_all=: 4 : 0
NB. 3/4 bezier
NB. Usage: mat_bezier3 u }: L0 
tmp0=.|: x +/ . * y
fx=. ({. tmp0)&p.      NB. set x(t) polynomial coefficients a0+a1xi+a2x2^2... 
fy=. ({: tmp0)&p.      NB. set y(t)
t01=. steps 0 1 10    NB. divede [0,1] for smooth Besier curves 
(fx t01),.fy t01       NB. calc polynomial
)

NB. ----test-------------------
plot_bezier_all=: 4 : 0
NB.  mat_bezier4 plot_bezier_simple L0
tmp=. x calculus_bezier_all y
pd 'reset'
pd {@|: y
pd 'color red'
pd {@|: tmp
pd 'show'
)

NB. ---2.----form--------------------------
NB. make each  boxed  unit 
form_bezier_all=: 4 : 0
NB. all  points 
NB. from each overlaped P(0,1,2,3)  
index=. (i.# y) e.  (<:x) * i. # y 
tmp0=. index <;.1  y
(}: tmp0) , L:0 }. {. L:0 tmp0
)

form_bezier4=: 3 : 0
NB. make all 4 points  box only
NB. from each overlaped P(0,1,2,3)  
index=. (i.# y) e. 3*i. # y 
tmp0=. index <;.1  y
(}: tmp0) , L:0 }. {. L:0 tmp0
)

form_bezier3=: 3 : 0
NB. Usage: form_bezier3  a=. i. 16 2
ind=: (#y){. (;(# y)#<1 0)
tmp=.ind <;.1 y
(}:tmp) , L:0 }.  {. L:0 tmp
)

NB. ---3. plot------------------------
plot_bezier0=: 4 : 0
NB. prototype # is 4/3 limited
NB. 4 plot_bezier EXG
NB. Usage:  3/4 plot_bezier// 3  is  1 1 0 1 # L0
select. # x
 case. 4  do. tmp=. calc_bezier4 y
 case. 3  do. tmp=. calc_bezier3 y 
 case. 5  do. tmp=. mat_bezier5  calc_bezier_all y
 case. 6  do. tmp=. mat_bezier6  calc_bezier_all y
end.
pd 'reset'
pd {@|: y
pd 'color red'
pd {@|:  tmp
pd 'show'
)

plot_bezier=: 4 : 0
NB.  Long type # is 7 or more 
select. # x
 case. 4  do. tmp=. calculus_bezier4 y
 case. 3  do. tmp=. calculus_bezier3 y 
 case. 5  do. tmp=. mat_bezier5  calculus_bezier_all y
 case. 6  do. tmp=. mat_bezier6  calculus_bezier_all y
end.
pd 'reset'
pd {@|: y
pd 'color red'
pd {@|: tmp
pd 'show'
)
NB. --4.-example data-------------------
L0=: 0 1,1 2,2 2,:3 1
L1=: 0 1,1 3,2 4,:4 2
L2=: 0 1,3 1,2 4,:4 2
L3=: 0 1,4 2,2 4,:1 0
NB. --void--------------------

calc_bezier_mix=: 4 : 0
NB. Usage: 4 4 3 4 4 calc_bezier_mix i. 25 2
NB. calc mix (3/4) all
mixform=. x form_bezier_mix y
num=.  x                         NB. ; # L:0 mixform  
ANS=. <''
for_ctr. i. # num do.
  ind=.  ctr { num 
  if. 4= ind do. tmp=. calc_bezier4 L:0 ctr { mixform end.
  if. 3= ind do. tmp=. calc_bezier3 L:0 ctr { mixform end.
  if. 5= ind do. tmp=. calc_bezier5 L:0 ctr { mixform end.
  ANS=. ANS,tmp 
end.
 ;("2) ,. }. ANS  NB. formed for graphics 
)

form_bezier_mix=: 4 : 0
NB. x is 3 4 3 4 4
index=:;* L:0({@> x), L:0  (<:@<:  L:0 {@>x ) #(L:0) 0 NB. set 3/4 of 1 0 0 (0)
index=. index , 1                NB. add tail one
tmp=: (>: +/ <: x ){. y          NB. set same length
tmp2=. index <;.1 tmp            NB. cut by index
(}: tmp2), L:0 (}. {. L:0 tmp2)  NB. overlaped one
)

NB. under is test
m_bezier4=:  0 0 0 1,0 0 3 _3,0 3 _6 3,: _1 3 _3 1 NB. Cubic moe Jform
m_bezier3=: 0 0 1,0 2 _2,: 1 _2 1             NB. Quadratic bezier 

NB. ------end Besier------------


