require 'trig numeric gl2'
coinsert 'jgl2'            NB. coclass

NB. ==================================================
NB. ---------------dwin by C.Reiter----------------
NB. C.Reiter
NB.* setWIN_WH v Sets the shape of the graphics window
NB. Example:
NB.    setWIN_WH 400 400
NB. sets a 400 by 400 pixel window
setWIN_WH=:3 : 'WIN_WH=:y'
setWIN_WH 1000 1000

NB. function that defines the next window name
nx_WIN=:3 : 0
try. WIN_num=: WIN_num + 1 catch. WIN_num=: 0 end.
WIN_nam=:'p',": WIN_num
)

dwin=: 3 : 0           NB. pixel sized window drawing
0 0 1 1 dwin y
:
'a c b d'=.x        NB. note non-alphabetic order
SC=:WIN_WH&*@((-&(a,d)) %((b-a),c-d)"1)"1
sz=.":WIN_WH
PN=:y,';   Window bounds are x: ',(":a),' to ',(":b),'   y: ',(":c),' to ',":d
nx_WIN ''
z=.'pc ',WIN_nam,' closeok;pn "',PN,'";cc g isigraph;setxywhx g 2 2 ',sz,';pas 2 2'
wd z,';pshow;'
)

NB.* dfillcolor v Internal utility to set fill color
dfillcolor=: 3 : 0     NB. Start Fill Color
wd 'psel ',WIN_nam
if. _1 e.y do. glbrushnull '' 
   else. glrgb y
   glbrush''
end.
)
NB. -----------------------------------------------------

popup_dwin=: 3 : 0
NB. y is 4 5 calc_each_poly (<MC),<MCPARAM
tmp=. find_center y
tmp dwin ''
)

NB. =======================================================
NB. -----polygon ------------------------
   dpoly=:3 : 0"1 2
0 0 0 dpoly y
:
Y=.x:^:_1 SC 2{."1 y
wd 'psel ',WIN_nam
dfillcolor x
glpolygon ,Y
glpaint''
)


NB. make difference table for each peaces
draw_dpoly0=: 4 : 0
NB. x is color
NB. y is MC 
NB. 120 255 120 draw_dpoly0 MC
popup_dwin y
x dpoly L:0 y
)

draw_dpoly=: 4 : 0
NB. x is color;Size
NB. y is (<MC),<MCPARAM 
NB. (120 255 120;6 7) draw_dpoly (<MC),<MCPARAM
'Color Size'=. x
tmp=. Size calc_each_poly y  
popup_dwin y
x dpoly L:0 y
)

draw_dpoly_over=: 4 : 0
NB. for overdrawing on shape/
NB. x y is same 
'Color Size'=. x
tmp=. Size calc_each_poly y  
Color dpoly L:0 tmp
)

NB. --2-colors  for polygon ----------------------------
draw_dpoly_grad_sub=: 4 : 0
NB. x is color;size_of_matrix /raw & column(ex. 4 5) 
NB. y is (<piece_data) , < diff_paramemter
NB.　 ((255 0 0 ;200 0 100), <4 5) draw_dpoly_grad (<IM),<IMPARAM
NB.  ( 0 200 0;4 5) draw_dpoly_over (<IM2),<IM2PARAM
'Color Size'=. x
tmp=. Size calc_each_poly y
'Ind0 Ind1'=. index_separate Size
(<Ind0 { ,tmp),<Ind1{,tmp NB. 'Gr0 Gr1'
)

draw_dpoly_grad=: 4 : 0
'Color Size'=. x
'Gr0 Gr1'=. x draw_dpoly_grad_sub y
tmp=. Size calc_each_poly y 
popup_dwin tmp 
'Color0 Color1'=. Color
Color0 dpoly L:0 Gr0
Color1 dpoly L:0 Gr1
)

draw_dpoly_grad_over=: 4 : 0
NB. x is color;size_of_matrix /raw & column(ex. 4 5) 
NB. y is (<piece_data) , < diff_paramemter
NB.　 ((255 0 0 ;200 0 100), <4 5) draw_dpoly_grad (<IM),<IMPARAM
NB.  ( 0 200 0;4 5) draw_dpoly_over (<IM2),<IM2PARAM
'Color Size'=. x
NB. popup_dwin tmp 
'Gr0 Gr1'=. x draw_dpoly_grad_sub y
'Color0 Color1'=. Color
Color0 dpoly L:0 Gr0
Color1 dpoly L:0 Gr1
)

NB. ======================================================
NB. --make-Komon patarn-----------------------------------
calc_each_poly=: 4 : 0
NB. Usage:  4 5 calc_each_poly (<MC),<MCPARAM 
NB. x is size-0f-matrix
NB. y is  (<piece),< parameter
'Piece Parameter'=. y
Size=. x
NB. using plus 
Piece + ("1) L:0  Size mk_diff_sub0 Parameter
)

NB. ------------komon frame---------------
mk_diff_sub0=: 4 : 0
NB. Usage: 4  5 mk_diff_sub0 MCPARAM //10 5;_2 5;6 _1
NB. x is size-of-matrix
NB. y is (<number of matrix),< base;diff x; diff y
'size_raw size_column'=. x
'base dfx dfy' =. y
X0=.|.{ base +"1 (|. i.size_column) */ dfx
tmp=. |: >{ L:0 X0 +"1 L:0 (|. i. size_raw) */ dfy
tmp - L:0 base
)


NB. ================================================
NB. ---find size of canvas/dwin------------------
maxmin=: (>./);(<./)
NB. find max and min for dwin
NB. y is 4 5 calc_each_poly (<MC),<MCPARAM
find_maxmin0=: 3 : ' maxmin ;("2) y'            NB. maxmin(x);maxmin(y)
find_maxmin=: 3 :  '; |. maxmin ;("2) y' NB. min(x,y):max(x,y)

find_center=: 3 : 0
NB. adjust canbus to square
tmp=. _2<\ 2 0 3 1 {; |. find_maxmin0 y          NB. left bottom --> right top
Center=. -:@;  |@:-/@|. L:0 tmp NB. center of gravity
Wide=. >. -:@:+/ ; 1r4&*@:-/ L:0 tmp NB. band 
tmp1=._2<\ Wide (+ , -@-) L:0 Center NB. range
ind=. ;*@>./ L:0 tmp1            NB. check _ or + 
ANS=. <''
for_ctr. i.2 do.
  if. _1 = ctr{ind do. PK=.  >./ ; ctr{tmp1  
   else.  PK=. <./ ; ctr{tmp1  end.
ANS=. ANS,<PK
end.
|. ; 2# L:0 }.ANS
)

NB. ----divide for 2 colors-------------------
index_separate=: 3 : 0
NB. for graduation 2 colors
NB. index_separate 3 5
ind=. i. # Oblic=. </. i. y NB. using oblique
tmp0=.;(-.2|ind)# Oblic
tmp1=.;(2|ind)#Oblic
tmp0;tmp1
)



NB. ==dline==========================
draw_dline0=: 3 : 0
NB. x is color
NB. y is MC 
NB. 120 255 120 draw_dline0 MC
popup_dwin y
dline  y
:
x dline y
)

draw_dline_over=: 4 : 0
NB. for overdrawing on shape/
NB. x y is same 
'Color Size'=. x
tmp=. Size calc_each_poly y  
Color dline L:0 tmp
)

dline=: 3 : 0 "1 2    
0 0 0 dline y
:
Y=.x:^:_1 SC 2{."1 y
wd 'psel ',WIN_nam
glrgb x
glpen 1 0
gllines ,Y
glpaint ''
)


dline2=: 3 : 0 "1 2
NB. modifyed dline// middle line
0 0 0 dline y
:
Y=. x:^:_1 SC 2{."1 y
wd 'psel ',WIN_nam
glrgb x
glpen 2,PS_SOLID   NB. pen 3/solid
gllines ,Y
glpaint ''
)

NB. ----------------------------
NB. 3-1 line
draw_dline_grad=: 4 : 0
'Color Size'=. x
'Gr0 Gr1'=. x draw_dpoly_grad_sub y
tmp=. Size calc_each_poly y 
popup_dwin tmp 
'Color0 Color1'=. Color
Color0 dline2 L:0 Gr0
Color1 dline2 L:0 Gr1
)



NB. **************************************
NB. homogeneous Coordinates 
NB. elongation(scaling) rotate transpose
elongm=: 3 :  '(y,1)* =i.3'
NB. elongm 2 3
rotm=: (cos, sin,0:),(-@sin,cos,0:),: 0: ,0:,1:
NB. rotm 1r4p1
transm=: 3 : '(=i.2), y,1'
NB. transm 2 3
mp=: +/ . *   NB. inner products

NB. ---------------------
rotm_elongm=: 4 : 0
NB.   (plot {|:) 4 10 rotm_elongm  1r4p1;0.4 0.4
NB. x parameter for circ_flower
NB. y parameter for rotm;elongm(x,y)
'ROT ELONG'=: y
tmp=. ((circ_flower x) ,.1 )mp rotm ROT 
clean }:"1 tmp mp elongm ELONG
)

NB. Utils
dline3=: 3 : 0 "1 2
NB. modifyed dline// bold line
0 0 0 dline y
:
Y=. x:^:_1 SC 2{."1 y
wd 'psel ',WIN_nam
glrgb x
glpen 3,PS_SOLID   NB. pen 3/solid
gllines ,Y
glpaint ''
)

mp=: +/ . * 

find_rotm_diff=: 4 : 0
NB. auto calc  diff parameter for rotm/
NB. Usage: 1r4p1  find_rotm_diff HM0PARAM
NB. x  is rot
NB. y is HM0PARAM
TGT=. ;("1),. y                      NB. make matrix
tmp=. clean }:"1 (TGT,.1) mp rotm x  NB. calc parameter of rotm
{({.tmp), (}. tmp)- {. tmp           NB. diff and form
)

NB. circle flower
circ_flower=: 3 : 0
NB. Usage:  circ_flower 3 1 
NB. petal is 2 * R0  --> 5 is 2.5 // 1 is 0.5  
'R0 Beki'=. y    
NB.  0.07 is Scale parameter 
R=. Beki ^~| sin R0 *  T=. 0.07 * i. 360
R polar_xy T
)
polar_xy=: 4 : '|: ;("1),.x * L:0 (cos;sin)L:0 y' NB. y is T
minmax_dwin=: ;@(<./ ; >./) L:0                   NB. find min-max 



NB. ***********************************************
NB. ----diagonal frame---------------------------
   mk_diff_sub1_diagonal=:4 : 0
NB.  (3 4;1r4p1) mk_diff_sub1_diagonal MC0PARAM
NB. x is Size ; rotate(pi)
NB. y is xxPARAM (base x y;diff x; diff y)
'Size Deg'=. x
'Base dfx dfy' =. y
tmp0=. Size mk_diff_sub0 y  
tmp1=. }:"1 L:0 (tmp0, (L:0) 1) mp  L:0 rotm Deg 
NB. find new diff
tmp2=. _2 2{. tmp1 NB. botom left 4 pieces 
Diff_new=: (<Base), (0 0;1 1){ tmp2 - L:0 ;{. {: tmp2
tmp3=. Size mk_diff_sub0 Diff_new
tmp3 - L:0 Base
)

calc_each_poly_diagonal=: 4 : 0
NB.  (0 0 255;6 7;1r4p1) draw_dpoly_diagonal (<MC0),<MC0PARAM
NB. x is size-0f-matrix ; radian
NB. y is  (<piece),< parameter
'Size Diag'=. x
'Piece Parameter'=. y
P0=. }:"1 ( Piece,.1) mp rotm Diag
P0 + ("1) L:0  x mk_diff_sub1_diagonal Parameter
)

draw_dpoly_diagonal=: 4 : 0
NB. x is color;size_of_matrix /raw & column(ex. 4 5) 
NB. y is (<piece_data) , < diff_paramemter
NB. (255 0 255;4 5) draw_dpoly (<MC0),<MC0PARAM
'Color Size Diag'=. x
tmp=. (Size;Diag) calc_each_poly_diagonal y  
NB. tmp=. Size u y
popup_dwin tmp
Color dpoly L:0 tmp
)

draw_dpoly_over_diagonal=: 4 : 0
NB. (255 0 255;4 5) draw_dpoly (<MC0),<MC0PARAM
'Color Size Diag'=. x
tmp=. (Size;Diag) calc_each_poly_diagonal y  
NB. popup_dwin tmp
Color dpoly L:0 tmp
)

